<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:ie="http://xml.insee.fr/schema" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text"/>
  <xsl:template match="*|@*">
    <xsl:apply-templates select="*|@*"/>
  </xsl:template>
  <xsl:template match="*[ie:NIR and ie:CleNIR]">
    <xsl:text> Contrôle NIRAvecCle, élément </xsl:text>
    <xsl:value-of select="name()"/>
    <xsl:call-template name="controle_clé_nir">
      <xsl:with-param name="NIR" select="ie:NIR"/>
      <xsl:with-param name="clé" select="ie:CleNIR"/>
    </xsl:call-template>
    <xsl:text/>
  </xsl:template>
  <xsl:template match="*[@ie:nir and @ie:cleNIR]">
    <xsl:text> Contrôle NIRAvecCle, élément </xsl:text>
    <xsl:value-of select="name()"/>
    <xsl:call-template name="controle_clé_nir">
      <xsl:with-param name="NIR" select="@ie:nir"/>
      <xsl:with-param name="clé" select="@ie:clNIR"/>
    </xsl:call-template>
    <xsl:text/>
  </xsl:template>
  <xsl:template match="@ie:nirAvecCle">
    <xsl:text> Contrôle NIR_Avec_Clé, élément </xsl:text>
    <xsl:value-of select="name()"/>
    <xsl:call-template name="controle_clé_nir"/>
    <xsl:text/>
  </xsl:template>
  <xsl:template name="controle_clé_nir">
    <xsl:param name="NIR" select="substring(., 1, 13)"/>
    <xsl:param name="clé" select="substring(., 14, 2)"/>
    <xsl:variable name="NIR-ajusté">
      <xsl:choose>
        <xsl:when test="contains($NIR, 'A')">
          <xsl:value-of select="number(translate($NIR, 'A', '0')) - 1000000"/>
        </xsl:when>
        <xsl:when test="contains($NIR, 'B')">
          <xsl:value-of select="number(translate($NIR, 'B', '0')) - 2000000"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$NIR"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="clé_calculée" select="97 - ($NIR-ajusté mod 97)"/>
    <xsl:choose>
      <xsl:when test="$clé = $clé_calculée">
        <xsl:text> Correct</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text> Erreur, la clé devrait être : </xsl:text>
        <xsl:value-of select="$clé_calculée"/>
        <xsl:text> (et non </xsl:text>
        <xsl:value-of select="$clé"/>
        <xsl:text>). </xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:transform>