<?xml version="1.0" encoding="UTF-8"?>
<xsl:transform xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text"/>
  <xsl:template match="*|@*">
    <xsl:apply-templates select="*|@*"/>
  </xsl:template>
  <xsl:template match="ie:SIREN|ie:NIC|@ie:siren|@ie:nic">
    <xsl:value-of select="name()"/>
    <xsl:text/>
    <xsl:value-of select="."/>
    <xsl:text> : </xsl:text>
    <xsl:call-template name="controle-luhn"/>
    <xsl:text/>
  </xsl:template>
  <xsl:template name="controle-luhn">
    <xsl:param name="numero" select="normalize-space(.)"/>
    <xsl:param name="somme" select="0"/>
    <xsl:param name="indice" select="1"/>
    <xsl:choose>
      <xsl:when test="string-length($numero)=0"><!-- Nous arrivons ici après le dernier chiffre -->
        <xsl:choose>
          <xsl:when test="$somme mod 10 = 0">
            <xsl:text>Correct</xsl:text>
          </xsl:when>
          <xsl:otherwise>
            <xsl:text>Erreur : </xsl:text>
            <xsl:value-of select="$somme"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>
      <xsl:when test="$indice mod 2 = 0"><!-- Cas des chiffres d'indice pair -->
        <xsl:call-template name="controle-luhn">
          <xsl:with-param name="numero" select="substring($numero, 2)"/>
          <xsl:with-param name="somme" select="$somme + substring($numero, 1, 1)"/>
          <xsl:with-param name="indice" select="$indice + 1"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise><!-- Cas des chiffres d'indice impair -->
        <xsl:variable name="double" select="concat(substring($numero, 1, 1) * 2, '0') "/>
        <xsl:call-template name="controle-luhn">
          <xsl:with-param name="numero" select="substring($numero, 2)"/>
          <xsl:with-param name="somme" select="$somme + substring($double, 1, 1) + substring($double, 2, 1)"/>
          <xsl:with-param name="indice" select="$indice + 1"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:transform>
